


#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "intarroutput.h"
#include "intarrinput.h"

#include "intinput.h"
#include "intoutput.h"

#include "floatinput.h"
#include "floatoutput.h"

#include "floatarrinput.h"
#include "floatarroutput.h"

#include <QTime>
#include <QFileDialog>

// libs for type identification
#include <limits>
#include <stdint.h>

void MainWindow::AddIOPanel(iopanel* Panel)
{
    MainContainer->addTab(Panel, Panel->GetName());
}

MainWindow::MainWindow (QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    log = ui->LogWidget;
    QObject::connect(ui->ClearBtn, SIGNAL(clicked(bool)),log,SLOT(clear()));

    comedit = ui->comEdit;
    QObject::connect(ui->cntButton, SIGNAL(clicked(bool)),this,SLOT(connectButton()));
    QObject::connect(ui->dcntButton,SIGNAL(clicked(bool)),this,SLOT(dconnectButton()));

    // ToolTip
    #ifdef Q_OS_WIN32
    this->comedit->setToolTip("Example:\ncom:\\\\.\\COM12\nxi-net://192.168.0.1/00001234");
    #else
        #ifdef Q_OS_LINUX
    this->comedit->setToolTip("Example:\ncom:///dev/tty/ttyACM34\nxi-net://192.168.0.1/00001234");
        #else
    this->comedit->setToolTip("Example:\ncom:\\\\.\\COM12\ncom:///dev/tty/ttyACM34\nemu:///var/lib/ximc/virtual56.dat\nxi-net://192.168.0.1/00001234");
        #endif
    #endif

    // Main tab widget
    MainContainer = new Container();

    this->ui->verticalLayout->addWidget(MainContainer);

    // search panel
    QObject::connect(ui->SearchEdit, SIGNAL(textChanged(QString)), this, SLOT(SearchSlot(QString)));

    // profile get/set slots
    QObject::connect(ui->GetProfileBtn, SIGNAL(clicked(bool)), this, SLOT(GetProfileSlot()));
    QObject::connect(ui->SetProfileBtn, SIGNAL(clicked(bool)), this, SLOT(SetProfileSlot()));

    /* commands
     * THIS CODE IS AUTOGENERATED
     */

    

    

    // command get_measurement
    get_measurementiop = new iopanel(NULL, "get_measurement");
    this->AddIOPanel(get_measurementiop);
        get_measurementFrameNumberinputwidget = new IntInput(NULL,"FrameNumber", "uint16_t",std::numeric_limits<uint16_t>::min(),std::numeric_limits<uint16_t>::max());
    get_measurementiop->AddRequest(get_measurementFrameNumberinputwidget);
    
    get_measurementFrameNumberinputwidget->AddConst("FRAME_SIZE", IVM_FRAME_SIZE);

        get_measurementVoltageoutputwidget = new FloatArrOutput(NULL,"Voltage", "float[25]");
    get_measurementiop->AddResponse(get_measurementVoltageoutputwidget);
    
        get_measurementCurrentoutputwidget = new FloatArrOutput(NULL,"Current", "float[25]");
    get_measurementiop->AddResponse(get_measurementCurrentoutputwidget);
    

    QObject::connect(get_measurementiop->PB, SIGNAL(clicked(bool)), this, SLOT(get_measurementPressSlot(bool)));


    // command get_identity_information
    get_identity_informationiop = new iopanel(NULL, "get_identity_information");
    this->AddIOPanel(get_identity_informationiop);
        get_identity_informationManufactureroutputwidget = new IntArrOutput(NULL,"Manufacturer", "uint8_t[16]");
    get_identity_informationiop->AddResponse(get_identity_informationManufactureroutputwidget);
    
        get_identity_informationProductNameoutputwidget = new IntArrOutput(NULL,"ProductName", "uint8_t[16]");
    get_identity_informationiop->AddResponse(get_identity_informationProductNameoutputwidget);
    
        get_identity_informationControllerNameoutputwidget = new IntArrOutput(NULL,"ControllerName", "uint8_t[16]");
    get_identity_informationiop->AddResponse(get_identity_informationControllerNameoutputwidget);
    
        get_identity_informationHardwareMajoroutputwidget = new IntOutput(NULL,"HardwareMajor", "uint8_t");
    get_identity_informationiop->AddResponse(get_identity_informationHardwareMajoroutputwidget);
    
        get_identity_informationHardwareMinoroutputwidget = new IntOutput(NULL,"HardwareMinor", "uint8_t");
    get_identity_informationiop->AddResponse(get_identity_informationHardwareMinoroutputwidget);
    
        get_identity_informationHardwareBugfixoutputwidget = new IntOutput(NULL,"HardwareBugfix", "uint16_t");
    get_identity_informationiop->AddResponse(get_identity_informationHardwareBugfixoutputwidget);
    
        get_identity_informationBootloaderMajoroutputwidget = new IntOutput(NULL,"BootloaderMajor", "uint8_t");
    get_identity_informationiop->AddResponse(get_identity_informationBootloaderMajoroutputwidget);
    
        get_identity_informationBootloaderMinoroutputwidget = new IntOutput(NULL,"BootloaderMinor", "uint8_t");
    get_identity_informationiop->AddResponse(get_identity_informationBootloaderMinoroutputwidget);
    
        get_identity_informationBootloaderBugfixoutputwidget = new IntOutput(NULL,"BootloaderBugfix", "uint16_t");
    get_identity_informationiop->AddResponse(get_identity_informationBootloaderBugfixoutputwidget);
    
        get_identity_informationFirmwareMajoroutputwidget = new IntOutput(NULL,"FirmwareMajor", "uint8_t");
    get_identity_informationiop->AddResponse(get_identity_informationFirmwareMajoroutputwidget);
    
        get_identity_informationFirmwareMinoroutputwidget = new IntOutput(NULL,"FirmwareMinor", "uint8_t");
    get_identity_informationiop->AddResponse(get_identity_informationFirmwareMinoroutputwidget);
    
        get_identity_informationFirmwareBugfixoutputwidget = new IntOutput(NULL,"FirmwareBugfix", "uint16_t");
    get_identity_informationiop->AddResponse(get_identity_informationFirmwareBugfixoutputwidget);
    
        get_identity_informationSerialNumberoutputwidget = new IntOutput(NULL,"SerialNumber", "uint32_t");
    get_identity_informationiop->AddResponse(get_identity_informationSerialNumberoutputwidget);
    
        get_identity_informationReservedoutputwidget = new IntArrOutput(NULL,"Reserved", "uint8_t[8]");
    get_identity_informationiop->AddResponse(get_identity_informationReservedoutputwidget);
    

    QObject::connect(get_identity_informationiop->PB, SIGNAL(clicked(bool)), this, SLOT(get_identity_informationPressSlot(bool)));


    // command start_autocalibration
    start_autocalibrationiop = new iopanel(NULL, "start_autocalibration");
    this->AddIOPanel(start_autocalibrationiop);
        start_autocalibrationResultoutputwidget = new IntOutput(NULL,"Result", "uint8_t");
    start_autocalibrationiop->AddResponse(start_autocalibrationResultoutputwidget);
    
    start_autocalibrationResultoutputwidget->AddConst("CALIBRATION_OK", IVM_CALIBRATION_OK);

    QObject::connect(start_autocalibrationiop->PB, SIGNAL(clicked(bool)), this, SLOT(start_autocalibrationPressSlot(bool)));


    // command get_status
    get_statusiop = new iopanel(NULL, "get_status");
    this->AddIOPanel(get_statusiop);
        get_statusStatusoutputwidget = new IntOutput(NULL,"Status", "uint32_t");
    get_statusiop->AddResponse(get_statusStatusoutputwidget);
    
    get_statusStatusoutputwidget->AddConst("STATUS_OK", IVM_STATUS_OK);
        get_statusTempoutputwidget = new IntOutput(NULL,"Temp", "int16_t");
    get_statusiop->AddResponse(get_statusTempoutputwidget);
    
        get_statusReservedoutputwidget = new IntArrOutput(NULL,"Reserved", "uint8_t[48]");
    get_statusiop->AddResponse(get_statusReservedoutputwidget);
    

    QObject::connect(get_statusiop->PB, SIGNAL(clicked(bool)), this, SLOT(get_statusPressSlot(bool)));


    // command get_measurement_settings
    get_measurement_settingsiop = new iopanel(NULL, "get_measurement_settings");
    this->AddIOPanel(get_measurement_settingsiop);
        get_measurement_settingsSamplingRateoutputwidget = new FloatOutput(NULL,"SamplingRate", "float");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsSamplingRateoutputwidget);
    
        get_measurement_settingsProbeSignalFrequencyoutputwidget = new FloatOutput(NULL,"ProbeSignalFrequency", "float");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsProbeSignalFrequencyoutputwidget);
    
        get_measurement_settingsNumberPointsoutputwidget = new IntOutput(NULL,"NumberPoints", "uint32_t");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsNumberPointsoutputwidget);
    
    get_measurement_settingsNumberPointsoutputwidget->AddConst("MIN_NUMBER_POINTS", IVM_MIN_NUMBER_POINTS);
    get_measurement_settingsNumberPointsoutputwidget->AddConst("MAX_NUMBER_POINTS", IVM_MAX_NUMBER_POINTS);
        get_measurement_settingsNumberChargePointsoutputwidget = new IntOutput(NULL,"NumberChargePoints", "uint32_t");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsNumberChargePointsoutputwidget);
    
        get_measurement_settingsMaxVoltageoutputwidget = new FloatOutput(NULL,"MaxVoltage", "float");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsMaxVoltageoutputwidget);
    
        get_measurement_settingsReserved0outputwidget = new IntArrOutput(NULL,"Reserved0", "uint8_t[4]");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsReserved0outputwidget);
    
        get_measurement_settingsCurrentSensorModeoutputwidget = new IntOutput(NULL,"CurrentSensorMode", "uint32_t");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsCurrentSensorModeoutputwidget);
    
    get_measurement_settingsCurrentSensorModeoutputwidget->AddConst("CURRENT_SENSE_MODE_ISOLATED", IVM_CURRENT_SENSE_MODE_ISOLATED);
    get_measurement_settingsCurrentSensorModeoutputwidget->AddConst("CURRENT_SENSE_MODE_I_LOW", IVM_CURRENT_SENSE_MODE_I_LOW);
    get_measurement_settingsCurrentSensorModeoutputwidget->AddConst("CURRENT_SENSE_MODE_I_MID", IVM_CURRENT_SENSE_MODE_I_MID);
    get_measurement_settingsCurrentSensorModeoutputwidget->AddConst("CURRENT_SENSE_MODE_I_HIGH", IVM_CURRENT_SENSE_MODE_I_HIGH);
        get_measurement_settingsOutputModeoutputwidget = new IntOutput(NULL,"OutputMode", "uint8_t");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsOutputModeoutputwidget);
    
    get_measurement_settingsOutputModeoutputwidget->AddConst("OUT_MODE_PROBE_SIGNAL_CONTINUOUS", IVM_OUT_MODE_PROBE_SIGNAL_CONTINUOUS);
    get_measurement_settingsOutputModeoutputwidget->AddConst("OUT_MODE_GROUNDED_CONTINUOUS", IVM_OUT_MODE_GROUNDED_CONTINUOUS);
    get_measurement_settingsOutputModeoutputwidget->AddConst("OUT_MODE_PROBE_SIGNAL_WITH_GROUNDING", IVM_OUT_MODE_PROBE_SIGNAL_WITH_GROUNDING);
        get_measurement_settingsReserved1outputwidget = new IntArrOutput(NULL,"Reserved1", "uint8_t[19]");
    get_measurement_settingsiop->AddResponse(get_measurement_settingsReserved1outputwidget);
    

    QObject::connect(get_measurement_settingsiop->PB, SIGNAL(clicked(bool)), this, SLOT(get_measurement_settingsPressSlot(bool)));


    // command set_measurement_settings
    set_measurement_settingsiop = new iopanel(NULL, "set_measurement_settings");
    this->AddIOPanel(set_measurement_settingsiop);
        set_measurement_settingsSamplingRateinputwidget = new FloatInput(NULL,"SamplingRate", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_measurement_settingsiop->AddRequest(set_measurement_settingsSamplingRateinputwidget);
    

        set_measurement_settingsProbeSignalFrequencyinputwidget = new FloatInput(NULL,"ProbeSignalFrequency", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_measurement_settingsiop->AddRequest(set_measurement_settingsProbeSignalFrequencyinputwidget);
    

        set_measurement_settingsNumberPointsinputwidget = new IntInput(NULL,"NumberPoints", "uint32_t",std::numeric_limits<uint32_t>::min(),std::numeric_limits<uint32_t>::max());
    set_measurement_settingsiop->AddRequest(set_measurement_settingsNumberPointsinputwidget);
    
    set_measurement_settingsNumberPointsinputwidget->AddConst("MIN_NUMBER_POINTS", IVM_MIN_NUMBER_POINTS);
    set_measurement_settingsNumberPointsinputwidget->AddConst("MAX_NUMBER_POINTS", IVM_MAX_NUMBER_POINTS);

        set_measurement_settingsNumberChargePointsinputwidget = new IntInput(NULL,"NumberChargePoints", "uint32_t",std::numeric_limits<uint32_t>::min(),std::numeric_limits<uint32_t>::max());
    set_measurement_settingsiop->AddRequest(set_measurement_settingsNumberChargePointsinputwidget);
    

        set_measurement_settingsMaxVoltageinputwidget = new FloatInput(NULL,"MaxVoltage", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_measurement_settingsiop->AddRequest(set_measurement_settingsMaxVoltageinputwidget);
    

        set_measurement_settingsReserved0inputwidget = new IntArrInput(NULL,"Reserved0", "uint8_t[4]",std::numeric_limits<uint8_t>::min(),std::numeric_limits<uint8_t>::max(),4);
    set_measurement_settingsiop->AddRequest(set_measurement_settingsReserved0inputwidget);
    

        set_measurement_settingsCurrentSensorModeinputwidget = new IntInput(NULL,"CurrentSensorMode", "uint32_t",std::numeric_limits<uint32_t>::min(),std::numeric_limits<uint32_t>::max());
    set_measurement_settingsiop->AddRequest(set_measurement_settingsCurrentSensorModeinputwidget);
    
    set_measurement_settingsCurrentSensorModeinputwidget->AddConst("CURRENT_SENSE_MODE_ISOLATED", IVM_CURRENT_SENSE_MODE_ISOLATED);
    set_measurement_settingsCurrentSensorModeinputwidget->AddConst("CURRENT_SENSE_MODE_I_LOW", IVM_CURRENT_SENSE_MODE_I_LOW);
    set_measurement_settingsCurrentSensorModeinputwidget->AddConst("CURRENT_SENSE_MODE_I_MID", IVM_CURRENT_SENSE_MODE_I_MID);
    set_measurement_settingsCurrentSensorModeinputwidget->AddConst("CURRENT_SENSE_MODE_I_HIGH", IVM_CURRENT_SENSE_MODE_I_HIGH);

        set_measurement_settingsOutputModeinputwidget = new IntInput(NULL,"OutputMode", "uint8_t",std::numeric_limits<uint8_t>::min(),std::numeric_limits<uint8_t>::max());
    set_measurement_settingsiop->AddRequest(set_measurement_settingsOutputModeinputwidget);
    
    set_measurement_settingsOutputModeinputwidget->AddConst("OUT_MODE_PROBE_SIGNAL_CONTINUOUS", IVM_OUT_MODE_PROBE_SIGNAL_CONTINUOUS);
    set_measurement_settingsOutputModeinputwidget->AddConst("OUT_MODE_GROUNDED_CONTINUOUS", IVM_OUT_MODE_GROUNDED_CONTINUOUS);
    set_measurement_settingsOutputModeinputwidget->AddConst("OUT_MODE_PROBE_SIGNAL_WITH_GROUNDING", IVM_OUT_MODE_PROBE_SIGNAL_WITH_GROUNDING);

        set_measurement_settingsReserved1inputwidget = new IntArrInput(NULL,"Reserved1", "uint8_t[19]",std::numeric_limits<uint8_t>::min(),std::numeric_limits<uint8_t>::max(),19);
    set_measurement_settingsiop->AddRequest(set_measurement_settingsReserved1inputwidget);
    


    QObject::connect(set_measurement_settingsiop->PB, SIGNAL(clicked(bool)), this, SLOT(set_measurement_settingsPressSlot(bool)));

        set_measurement_settingsiop->SetTypeSetter();
        QObject::connect(set_measurement_settingsiop->CallGetterBtn, SIGNAL(clicked(bool)), this, SLOT(set_measurement_settingsCallGetterPressSlot(bool)));

    // command start_measurement
    start_measurementiop = new iopanel(NULL, "start_measurement");
    this->AddIOPanel(start_measurementiop);

    QObject::connect(start_measurementiop->PB, SIGNAL(clicked(bool)), this, SLOT(start_measurementPressSlot(bool)));


    // command check_measurement_status
    check_measurement_statusiop = new iopanel(NULL, "check_measurement_status");
    this->AddIOPanel(check_measurement_statusiop);
        check_measurement_statusReadyStatusoutputwidget = new IntOutput(NULL,"ReadyStatus", "uint8_t");
    check_measurement_statusiop->AddResponse(check_measurement_statusReadyStatusoutputwidget);
    
    check_measurement_statusReadyStatusoutputwidget->AddConst("MEASUREMENT_NOT_COMPLETE", IVM_MEASUREMENT_NOT_COMPLETE);
    check_measurement_statusReadyStatusoutputwidget->AddConst("MEASUREMENT_COMPLETE", IVM_MEASUREMENT_COMPLETE);
        check_measurement_statusReservedoutputwidget = new IntArrOutput(NULL,"Reserved", "uint8_t[15]");
    check_measurement_statusiop->AddResponse(check_measurement_statusReservedoutputwidget);
    

    QObject::connect(check_measurement_statusiop->PB, SIGNAL(clicked(bool)), this, SLOT(check_measurement_statusPressSlot(bool)));


    // command get_calibration_settings
    get_calibration_settingsiop = new iopanel(NULL, "get_calibration_settings");
    this->AddIOPanel(get_calibration_settingsiop);
        get_calibration_settingsReserved0outputwidget = new IntArrOutput(NULL,"Reserved0", "uint8_t[8]");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsReserved0outputwidget);
    
        get_calibration_settingsADCMultoutputwidget = new FloatOutput(NULL,"ADCMult", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsADCMultoutputwidget);
    
        get_calibration_settingsADCVOffsetoutputwidget = new FloatOutput(NULL,"ADCVOffset", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsADCVOffsetoutputwidget);
    
        get_calibration_settingsCurrentSense1Multoutputwidget = new FloatOutput(NULL,"CurrentSense1Mult", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsCurrentSense1Multoutputwidget);
    
        get_calibration_settingsCurrentSense1Offsetoutputwidget = new FloatOutput(NULL,"CurrentSense1Offset", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsCurrentSense1Offsetoutputwidget);
    
        get_calibration_settingsCurrentSense2Multoutputwidget = new FloatOutput(NULL,"CurrentSense2Mult", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsCurrentSense2Multoutputwidget);
    
        get_calibration_settingsCurrentSense2Offsetoutputwidget = new FloatOutput(NULL,"CurrentSense2Offset", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsCurrentSense2Offsetoutputwidget);
    
        get_calibration_settingsCurrentSense3Multoutputwidget = new FloatOutput(NULL,"CurrentSense3Mult", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsCurrentSense3Multoutputwidget);
    
        get_calibration_settingsCurrentSense3Offsetoutputwidget = new FloatOutput(NULL,"CurrentSense3Offset", "float");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsCurrentSense3Offsetoutputwidget);
    
        get_calibration_settingsReserved1outputwidget = new IntArrOutput(NULL,"Reserved1", "uint8_t[72]");
    get_calibration_settingsiop->AddResponse(get_calibration_settingsReserved1outputwidget);
    

    QObject::connect(get_calibration_settingsiop->PB, SIGNAL(clicked(bool)), this, SLOT(get_calibration_settingsPressSlot(bool)));


    // command set_calibration_settings
    set_calibration_settingsiop = new iopanel(NULL, "set_calibration_settings");
    this->AddIOPanel(set_calibration_settingsiop);
        set_calibration_settingsReserved0inputwidget = new IntArrInput(NULL,"Reserved0", "uint8_t[8]",std::numeric_limits<uint8_t>::min(),std::numeric_limits<uint8_t>::max(),8);
    set_calibration_settingsiop->AddRequest(set_calibration_settingsReserved0inputwidget);
    

        set_calibration_settingsADCMultinputwidget = new FloatInput(NULL,"ADCMult", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsADCMultinputwidget);
    

        set_calibration_settingsADCVOffsetinputwidget = new FloatInput(NULL,"ADCVOffset", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsADCVOffsetinputwidget);
    

        set_calibration_settingsCurrentSense1Multinputwidget = new FloatInput(NULL,"CurrentSense1Mult", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsCurrentSense1Multinputwidget);
    

        set_calibration_settingsCurrentSense1Offsetinputwidget = new FloatInput(NULL,"CurrentSense1Offset", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsCurrentSense1Offsetinputwidget);
    

        set_calibration_settingsCurrentSense2Multinputwidget = new FloatInput(NULL,"CurrentSense2Mult", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsCurrentSense2Multinputwidget);
    

        set_calibration_settingsCurrentSense2Offsetinputwidget = new FloatInput(NULL,"CurrentSense2Offset", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsCurrentSense2Offsetinputwidget);
    

        set_calibration_settingsCurrentSense3Multinputwidget = new FloatInput(NULL,"CurrentSense3Mult", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsCurrentSense3Multinputwidget);
    

        set_calibration_settingsCurrentSense3Offsetinputwidget = new FloatInput(NULL,"CurrentSense3Offset", "float",-std::numeric_limits<float>::max(),std::numeric_limits<float>::max());
    set_calibration_settingsiop->AddRequest(set_calibration_settingsCurrentSense3Offsetinputwidget);
    

        set_calibration_settingsReserved1inputwidget = new IntArrInput(NULL,"Reserved1", "uint8_t[72]",std::numeric_limits<uint8_t>::min(),std::numeric_limits<uint8_t>::max(),72);
    set_calibration_settingsiop->AddRequest(set_calibration_settingsReserved1inputwidget);
    


    QObject::connect(set_calibration_settingsiop->PB, SIGNAL(clicked(bool)), this, SLOT(set_calibration_settingsPressSlot(bool)));

        set_calibration_settingsiop->SetTypeSetter();
        QObject::connect(set_calibration_settingsiop->CallGetterBtn, SIGNAL(clicked(bool)), this, SLOT(set_calibration_settingsCallGetterPressSlot(bool)));

    // command get_measurement_raw
    get_measurement_rawiop = new iopanel(NULL, "get_measurement_raw");
    this->AddIOPanel(get_measurement_rawiop);
        get_measurement_rawFrameinputwidget = new IntInput(NULL,"Frame", "uint16_t",std::numeric_limits<uint16_t>::min(),std::numeric_limits<uint16_t>::max());
    get_measurement_rawiop->AddRequest(get_measurement_rawFrameinputwidget);
    

        get_measurement_rawADCHighCodeoutputwidget = new IntArrOutput(NULL,"ADCHighCode", "uint16_t[25]");
    get_measurement_rawiop->AddResponse(get_measurement_rawADCHighCodeoutputwidget);
    
        get_measurement_rawADCLowCodeoutputwidget = new IntArrOutput(NULL,"ADCLowCode", "uint16_t[25]");
    get_measurement_rawiop->AddResponse(get_measurement_rawADCLowCodeoutputwidget);
    

    QObject::connect(get_measurement_rawiop->PB, SIGNAL(clicked(bool)), this, SLOT(get_measurement_rawPressSlot(bool)));


    // command get_device_rank
    get_device_rankiop = new iopanel(NULL, "get_device_rank");
    this->AddIOPanel(get_device_rankiop);
        get_device_rankRankoutputwidget = new IntOutput(NULL,"Rank", "uint32_t");
    get_device_rankiop->AddResponse(get_device_rankRankoutputwidget);
    
    get_device_rankRankoutputwidget->AddConst("RANKING_NOT_SUPPORTED", IVM_RANKING_NOT_SUPPORTED);
    get_device_rankRankoutputwidget->AddConst("RANK_PRIMARY", IVM_RANK_PRIMARY);
        get_device_rankReserved0outputwidget = new IntArrOutput(NULL,"Reserved0", "uint8_t[128]");
    get_device_rankiop->AddResponse(get_device_rankReserved0outputwidget);
    

    QObject::connect(get_device_rankiop->PB, SIGNAL(clicked(bool)), this, SLOT(get_device_rankPressSlot(bool)));



    QObject::connect(ui->ClearBtn, SIGNAL(clicked(bool)),log,SLOT(clear()));

}

MainWindow::~MainWindow()
{
    ivm_close_device(&device);
    delete ui;
}


//--------------------------------------
void MainWindow::logAdd(QString str)
{
    log->addItem(QTime::currentTime().toString() + ": " +str);
    log->scrollToBottom();
}

//---------------------------------------
void MainWindow::logClear()
{
    log->clear();
}

//--------------------------connect\disconnect slots
void MainWindow::connectButton()
{
    ivm_close_device(&device);
    device = ivm_open_device(comedit->text().toStdString().c_str());

    if(device == device_undefined)
    {
        ivm_close_device(&device);
        logAdd(comedit->text()+ " device undefined");
    }
    else
    {
        logAdd(comedit->text()+ " connect");
    }

}

//------------------------------------------
void MainWindow::dconnectButton()
{
    ivm_close_device(&device);
    logAdd("Disconnect "+comedit->text());
}

/* slots for SEND buttons
 * THIS CODE IS AUTOGENERATED
 */



void MainWindow::get_measurementPressSlot(bool)
{
    int result = 0;
    ivm_in_get_measurement_t input;

    input.FrameNumber = get_measurementFrameNumberinputwidget->getValue<uint16_t>();

    ivm_out_get_measurement_t output;
    result = ivm_get_measurement(device,&input,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        get_measurementVoltageoutputwidget->setValue(output.Voltage, 25);
        get_measurementCurrentoutputwidget->setValue(output.Current, 25);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_get_measurement returned "+QString::number(result));
}

void MainWindow::get_identity_informationPressSlot(bool)
{
    int result = 0;
    ivm_get_identity_information_t output;
    result = ivm_get_identity_information(device,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        get_identity_informationManufactureroutputwidget->setValue(output.Manufacturer, 16);
        get_identity_informationProductNameoutputwidget->setValue(output.ProductName, 16);
        get_identity_informationControllerNameoutputwidget->setValue(output.ControllerName, 16);
        get_identity_informationHardwareMajoroutputwidget->setValue(output.HardwareMajor);
        get_identity_informationHardwareMinoroutputwidget->setValue(output.HardwareMinor);
        get_identity_informationHardwareBugfixoutputwidget->setValue(output.HardwareBugfix);
        get_identity_informationBootloaderMajoroutputwidget->setValue(output.BootloaderMajor);
        get_identity_informationBootloaderMinoroutputwidget->setValue(output.BootloaderMinor);
        get_identity_informationBootloaderBugfixoutputwidget->setValue(output.BootloaderBugfix);
        get_identity_informationFirmwareMajoroutputwidget->setValue(output.FirmwareMajor);
        get_identity_informationFirmwareMinoroutputwidget->setValue(output.FirmwareMinor);
        get_identity_informationFirmwareBugfixoutputwidget->setValue(output.FirmwareBugfix);
        get_identity_informationSerialNumberoutputwidget->setValue(output.SerialNumber);
        get_identity_informationReservedoutputwidget->setValue(output.Reserved, 8);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_get_identity_information returned "+QString::number(result));
}

void MainWindow::start_autocalibrationPressSlot(bool)
{
    int result = 0;
    ivm_start_autocalibration_t output;
    result = ivm_start_autocalibration(device,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        start_autocalibrationResultoutputwidget->setValue(output.Result);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_start_autocalibration returned "+QString::number(result));
}

void MainWindow::get_statusPressSlot(bool)
{
    int result = 0;
    ivm_get_status_t output;
    result = ivm_get_status(device,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        get_statusStatusoutputwidget->setValue(output.Status);
        get_statusTempoutputwidget->setValue(output.Temp);
        get_statusReservedoutputwidget->setValue(output.Reserved, 48);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_get_status returned "+QString::number(result));
}

void MainWindow::get_measurement_settingsPressSlot(bool)
{
    int result = 0;
    ivm_measurement_settings_t output;
    result = ivm_get_measurement_settings(device,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        get_measurement_settingsSamplingRateoutputwidget->setValue(output.SamplingRate);
        get_measurement_settingsProbeSignalFrequencyoutputwidget->setValue(output.ProbeSignalFrequency);
        get_measurement_settingsNumberPointsoutputwidget->setValue(output.NumberPoints);
        get_measurement_settingsNumberChargePointsoutputwidget->setValue(output.NumberChargePoints);
        get_measurement_settingsMaxVoltageoutputwidget->setValue(output.MaxVoltage);
        get_measurement_settingsReserved0outputwidget->setValue(output.Reserved0, 4);
        get_measurement_settingsCurrentSensorModeoutputwidget->setValue(output.CurrentSensorMode);
        get_measurement_settingsOutputModeoutputwidget->setValue(output.OutputMode);
        get_measurement_settingsReserved1outputwidget->setValue(output.Reserved1, 19);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_get_measurement_settings returned "+QString::number(result));
}

void MainWindow::set_measurement_settingsPressSlot(bool)
{
    int result = 0;
    ivm_measurement_settings_t input;

    input.SamplingRate = set_measurement_settingsSamplingRateinputwidget->getValue();
    input.ProbeSignalFrequency = set_measurement_settingsProbeSignalFrequencyinputwidget->getValue();
    input.NumberPoints = set_measurement_settingsNumberPointsinputwidget->getValue<uint32_t>();
    input.NumberChargePoints = set_measurement_settingsNumberChargePointsinputwidget->getValue<uint32_t>();
    input.MaxVoltage = set_measurement_settingsMaxVoltageinputwidget->getValue();
    set_measurement_settingsReserved0inputwidget->getValue<uint8_t>(input.Reserved0);
    input.CurrentSensorMode = set_measurement_settingsCurrentSensorModeinputwidget->getValue<uint32_t>();
    input.OutputMode = set_measurement_settingsOutputModeinputwidget->getValue<uint8_t>();
    set_measurement_settingsReserved1inputwidget->getValue<uint8_t>(input.Reserved1);

    result = ivm_set_measurement_settings(device,&input);

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_set_measurement_settings returned "+QString::number(result));
}

void MainWindow::set_measurement_settingsCallGetterPressSlot(bool)
{
    get_measurement_settingsPressSlot(true);

    for (int i = 0; i < set_measurement_settingsiop->RequestsCount(); i++)
    {
        set_measurement_settingsiop->GetRequest(i)->SetText(get_measurement_settingsiop->GetResponse(i)->GetText());
    }
}
void MainWindow::start_measurementPressSlot(bool)
{
    int result = 0;
    result = ivm_start_measurement(device);

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_start_measurement returned "+QString::number(result));
}

void MainWindow::check_measurement_statusPressSlot(bool)
{
    int result = 0;
    ivm_check_measurement_status_t output;
    result = ivm_check_measurement_status(device,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        check_measurement_statusReadyStatusoutputwidget->setValue(output.ReadyStatus);
        check_measurement_statusReservedoutputwidget->setValue(output.Reserved, 15);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_check_measurement_status returned "+QString::number(result));
}

void MainWindow::get_calibration_settingsPressSlot(bool)
{
    int result = 0;
    ivm_calibration_settings_t output;
    result = ivm_get_calibration_settings(device,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        get_calibration_settingsReserved0outputwidget->setValue(output.Reserved0, 8);
        get_calibration_settingsADCMultoutputwidget->setValue(output.ADCMult);
        get_calibration_settingsADCVOffsetoutputwidget->setValue(output.ADCVOffset);
        get_calibration_settingsCurrentSense1Multoutputwidget->setValue(output.CurrentSense1Mult);
        get_calibration_settingsCurrentSense1Offsetoutputwidget->setValue(output.CurrentSense1Offset);
        get_calibration_settingsCurrentSense2Multoutputwidget->setValue(output.CurrentSense2Mult);
        get_calibration_settingsCurrentSense2Offsetoutputwidget->setValue(output.CurrentSense2Offset);
        get_calibration_settingsCurrentSense3Multoutputwidget->setValue(output.CurrentSense3Mult);
        get_calibration_settingsCurrentSense3Offsetoutputwidget->setValue(output.CurrentSense3Offset);
        get_calibration_settingsReserved1outputwidget->setValue(output.Reserved1, 72);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_get_calibration_settings returned "+QString::number(result));
}

void MainWindow::set_calibration_settingsPressSlot(bool)
{
    int result = 0;
    ivm_calibration_settings_t input;

    set_calibration_settingsReserved0inputwidget->getValue<uint8_t>(input.Reserved0);
    input.ADCMult = set_calibration_settingsADCMultinputwidget->getValue();
    input.ADCVOffset = set_calibration_settingsADCVOffsetinputwidget->getValue();
    input.CurrentSense1Mult = set_calibration_settingsCurrentSense1Multinputwidget->getValue();
    input.CurrentSense1Offset = set_calibration_settingsCurrentSense1Offsetinputwidget->getValue();
    input.CurrentSense2Mult = set_calibration_settingsCurrentSense2Multinputwidget->getValue();
    input.CurrentSense2Offset = set_calibration_settingsCurrentSense2Offsetinputwidget->getValue();
    input.CurrentSense3Mult = set_calibration_settingsCurrentSense3Multinputwidget->getValue();
    input.CurrentSense3Offset = set_calibration_settingsCurrentSense3Offsetinputwidget->getValue();
    set_calibration_settingsReserved1inputwidget->getValue<uint8_t>(input.Reserved1);

    result = ivm_set_calibration_settings(device,&input);

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_set_calibration_settings returned "+QString::number(result));
}

void MainWindow::set_calibration_settingsCallGetterPressSlot(bool)
{
    get_calibration_settingsPressSlot(true);

    for (int i = 0; i < set_calibration_settingsiop->RequestsCount(); i++)
    {
        set_calibration_settingsiop->GetRequest(i)->SetText(get_calibration_settingsiop->GetResponse(i)->GetText());
    }
}
void MainWindow::get_measurement_rawPressSlot(bool)
{
    int result = 0;
    ivm_in_get_measurement_raw_t input;

    input.Frame = get_measurement_rawFrameinputwidget->getValue<uint16_t>();

    ivm_out_get_measurement_raw_t output;
    result = ivm_get_measurement_raw(device,&input,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        get_measurement_rawADCHighCodeoutputwidget->setValue(output.ADCHighCode, 25);
        get_measurement_rawADCLowCodeoutputwidget->setValue(output.ADCLowCode, 25);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_get_measurement_raw returned "+QString::number(result));
}

void MainWindow::get_device_rankPressSlot(bool)
{
    int result = 0;
    ivm_get_device_rank_t output;
    result = ivm_get_device_rank(device,&output);
    if (result == result_ok || result == result_value_error)
    {
        
        get_device_rankRankoutputwidget->setValue(output.Rank);
        get_device_rankReserved0outputwidget->setValue(output.Reserved0, 128);

    }

    if (result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("ivm_get_device_rank returned "+QString::number(result));
}


void MainWindow::SearchSlot(QString str)
{
    MainContainer->Search(str);
}

void MainWindow::GetProfileSlot()
{
    QString FileName = QFileDialog::getSaveFileName(0, "Save profile...", "ivm.json", "JSON files (*.json);; All files (*)");

    if (FileName.isEmpty())
        return;

    QFile Profile(FileName);

    if (!Profile.open(QIODevice::WriteOnly))
    {
        this->logAdd("Error opening file");
        this->logAdd("Abort");
        return;
    }

    char *Buf = 0;

    int Result = ivm_get_profile(this->device, &Buf, malloc);

    if (Result == device_undefined)
    {
        ivm_close_device(&device);
    }

    logAdd("get_profile returned " + QString::number(Result));

    if ((Result != result_ok) && (Result != result_value_error))
    {
        logAdd("Abort");
        Profile.close();
        free(Buf);
        return;
    }

    Profile.write(Buf);

    if (Profile.error())
    {
        logAdd("File error:");
        logAdd(Profile.errorString());
        logAdd("Abort");
        free(Buf);
        return;
    }

    logAdd("Done");
    Profile.close();
    free(Buf);
}

void MainWindow::SetProfileSlot()
{
    QString FileName = QFileDialog::getOpenFileName(0, "Open profile...", ".json", "JSON files (*.json);; All files (*)");

    if (FileName.isEmpty())
        return;

    QFile Profile(FileName);

    if (!Profile.open(QIODevice::ReadOnly))
    {
        this->logAdd("Error opening file");
        this->logAdd("Abort");
        return;
    }
    static char *Buf;
    static unsigned int Size;

    Size = Profile.size();
    Buf = new char[Size]; // TODO: safe pointer?

    Profile.read(Buf, Size);
    Profile.close();

    if (Profile.error())
    {
        logAdd("File error:");
        logAdd(Profile.errorString());
        logAdd("Abort");
        delete[] Buf;
        return;
    }

    int Result = 0;
    // TODO: more safe try-catch block
    try
    {
        Result = ivm_set_profile(this->device, Buf);
        if (Result == device_undefined)
        {
            ivm_close_device(&device);
        }
    }
    catch(...)
    {
        logAdd("General error");
        logAdd("Abort");
        delete[] Buf;
        return;
    }
    logAdd("set_profile returned " + QString::number(Result));

    logAdd("Done");
    Profile.close();
}